#include "loadbullet_mode.h"
#include "logical_core.h"

LoadBulletMode::LoadBulletMode(LogicalCore *logical_core)
{
  MissionMode();
  logical_core_ = logical_core;
}

void LoadBulletMode::obtainedGoalState()
{
  ROS_INFO("Switch to OBTAINED_GOAL_STATE under LOAD_BULLET_MODE");
  logical_core_->ac_.sendGoal(logical_core_->bullet_loading_goal_);
  logical_core_->car_state_ = BUSY_STATE;
  ROS_INFO("Switch to BUSY_STATE");
}

void LoadBulletMode::busyState()
{
  if (logical_core_->ac_.getState()
      == actionlib::SimpleClientGoalState::SUCCEEDED)
  {
    logical_core_->car_state_ = IDLE_STATE;
    ROS_INFO("Arrived at loading bullet position ，switch to IDLE_STATE!");
    ros::Duration(3).sleep();
    if(logical_core_->go_to_load_bullet == 1)
    {
       logical_core_->go_to_load_bullet = 2;//
    }

  }
  else if (logical_core_->ac_.getState() == actionlib::SimpleClientGoalState::LOST)
    std::cout<<"Cannot make a plan!"<<std::endl;
}

void LoadBulletMode::idleState()
{
  ros::Duration(18).sleep();
  logical_core_->go_to_load_bullet = 3;
  ROS_INFO("Loading Bullet Finished!");
  ROS_INFO("Switch to the PATROL_MODE!");
  logical_core_->p_mission_mode_ = logical_core_->p_patrol_mode_;
//logical_core_->p_mission_mode_ = logical_core_->p_patrol_mode_;
}
