#include "moveback_mode.h"
#include "logical_core.h"
#include <ros/ros.h>

MoveBackMode::MoveBackMode(LogicalCore* logical_core)
{
  logical_core_ = logical_core;
}

void MoveBackMode::obtainedGoalState()
{
  ROS_INFO("[MOVEBACK MODE] [OBTAINED_GOAL_STATE]");
  logical_core_->ac_.sendGoal(logical_core_->moveback_goal);
  logical_core_->car_state_ = BUSY_STATE;
  ROS_INFO("[MOVEBACK MODE] [BUSY_STATE]");

}

void MoveBackMode::busyState()
{
  if (logical_core_->ac_.getState()
      == actionlib::SimpleClientGoalState::SUCCEEDED)
  {
    logical_core_->car_state_ = IDLE_STATE;
    ROS_INFO("MOVEBACK goal reached，switch to IDLE_STATE!");
  }
  else if (logical_core_->ac_.getState() == actionlib::SimpleClientGoalState::LOST)
    std::cout<<"Cannot make a plan!"<<std::endl;
}

void MoveBackMode::idleState()
{
  ROS_INFO("[MOVEBACK MODE] [IDLE_STATE]");
//if(!logical_core_->patrol_list_.empty())
//{
//  	 logical_core_->goal_      = logical_core_->patrol_list_.back();
//  	 logical_core_->car_state_ = OBTAINED_GOAL_STATE;
//}
  ROS_INFO("Arrived at the position to hide!");
  
  logical_core_->rotate_patrol_list(logical_core_->find_close_pos_in_list(logical_core_->patrol_list_));
  //rotate!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!to find target
  /////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////
  ////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////
  
  //wait for n seconds
  //roate ptz try to find target!!!!!!
  ROS_INFO("Switch to the PATROL_MODE!");
  logical_core_->p_mission_mode_ = logical_core_->p_patrol_mode_;
}
